<template>
  <div class="w-full">
    <div
      @click="
        authenticated
          ? handleGameEntryOpenWindow(gameForDisplay, 850, 850)
          : toggleLoginRegisterDialog()
      "
      class="w-full h-full flex flex-col-reverse overflow-hidden bg-background1 rounded-lg"
    >
      <div
        class="py-[5px] px-5 mt-[5px] mr-auto mb-[10px] ml-auto bg-primary rounded-2xl max-w-[120px] text-white text-xs"
      >
        {{ $t("play_now") }}
      </div>
      <h2 class="p-2 text-center text-sm">
        {{ gameForDisplay.GameNameForDisplay }}
      </h2>
      <div class="relative">
        <figure class="w-full text-center relative h-[4.68rem]">
          <img
            class="w-auto h-full inline-block max-w-full align-middle"
            v-lazy="gameForDisplay.GameIconUrl"
          />
        </figure>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from "vue";
import { IGameBsi } from "@/models/bsiGameList";
import SportDisplayModel from "@/components/sport/sportDisplayModel";
import { store } from "@/store";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";

export default defineComponent({
  name: "VerticalGameEntryComponent",
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
  },
  setup(props) {
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const authenticated = computed(() => store.state.auth);
    const { toggleLoginRegisterDialog } = commonHelper;
    return {
      gameForDisplay,
      authenticated,
      handleGameEntryOpenWindow,
      toggleLoginRegisterDialog,
    };
  },
});
</script>

<style scoped lang="scss">
.box-entry {
  height: 154.05px;
  position: relative;
  border-radius: 10px;
  box-sizing: border-box;
  border: 1px solid #393c68;
  width: 100%;
  overflow: hidden;
  cursor: pointer;

  .footer-entry {
    height: 35%;
    width: 100%;
    position: absolute;
    z-index: 1;
    bottom: 0;
    left: 0;
    color: var(--text5);

    .background-play-game {
      background-color: #393c68;
      opacity: 0.8;
      width: 100%;
      height: 100%;
      position: absolute;
      z-index: 0;
    }

    .game-name {
      margin-top: 2%;
      height: 50px;
      display: block;
      font-family: sans-serif;
      line-height: 40px;
      text-overflow: ellipsis;
      white-space: nowrap;
      font-size: 14px;
      text-align: center;
    }

    .btn-play-game {
      background: #ff4e00;
      border: 1px solid #ff4e00;
      border-radius: 25px;
      font-size: 16px;
      font-weight: 700;
      padding: 5px 20px;
      width: 100%;

      &:hover,
      &:focus {
        background: #009fe3;
        border-color: #009fe3;
        color: black;
      }
    }
  }
}
</style>
